#!/usr/bin/env python3
from terasense import processor as tp

source = tp.processor() # multithreading is on by default
source.SetExposure(3)
#In the multithreaded case you need to start data acquisition explicitly
source.start()

for i in range(100):
    data = source.read()
    #do something with data
    print(data)
#Call stop() to stop acquisition and join the acquisition and processing thread
source.stop()
