__svn_revision__ = '$Revision: 432 $'

#
# MSP430 text code format loader
#

def load(fd):
	"""
	Load segments from the specified file descriptor.
	Returns the list of (addr, code) tuples.
	"""
	segs = []
	addr = None
	data = None
	ls = fd.readlines()
	try:
		for l in ls:
			if l[0] == '@':
				if addr != None:
					segs += (addr, data)
				addr = int(l[1:], base=16)
				data = bytearray()
				# data_a = bytearray([])
				# data = bytes([])
				# print("Data array type:", type(data), data )
			elif l[0] == 'q':
				if addr is None:
					return None
				# print("Data_a:", type(data_a), data_a)
				segs.append((addr, data),)
				return segs
			else:
				byte_s = l.split()
				for b in byte_s:
					# a = b'\x02'
					# c = str(int(b, base=16))
					# print("Print b and a:", b, bytearray())
					# data.append(data, a)
					# data_a.extend(a)
					# print("int(b, base=16):", bytes([(int(b, base=16))])
					# data += chr(int(b, base=16))       
					data.extend(bytes.fromhex(b))                    
					# bytes(data)
					# print("Priting Data from file:", data, type(data))
	except:
		pass
	return None

def load_file(path):
	"""Load specified file"""
	f = None
	try:
		f = open(path)		
		return load(f)
	except:
		return None
	finally:
		if f is not None:
			f.close()
