#!/usr/bin/env python3
from terasense import processor as tp
import time

count = 0
def callback(data):
    global count
    #do something with data
    count +=1
    print(count, end=" ")
    
source = tp.processor() # multithreading is on by default
source.SetExposure(3)

#In the multithreaded case you need to start data acquisition explicitly
source.start(callback)

# Sleep 3 seconds or do something while acquisition is going on
time.sleep(3)

#stop() function should be called from the main thread, not from the callback
source.stop()
